package org.foxarmy.barcodescannerforemployees

import org.foxarmy.barcodescannerforemployees.dataclasses.AbstractProduct

class Parser constructor() {
    fun parse(text: String): AbstractProduct {
        var text = text

        var name = ""
        var netWeight = 0.0

        //Find volume in liters
        val litersRegex = Regex("[0-9+],[0-9*]\\s*[лЛ]")
        val foundLiters = litersRegex.find(text)
        if (foundLiters != null) {
            text = text.replace(foundLiters.groupValues[0], "")
            netWeight = stripNetWeight(foundLiters.groupValues[0])
        } else { // not found liters. Maybe milliliters?
            val millilitersRegex = Regex("[0-9+],[0-9*]\\s*((мл)|(МЛ)|(Мл))")
            val foundMilliliters = millilitersRegex.find(text)
            netWeight = if (foundMilliliters != null) {
                text = text.replace(foundMilliliters.groupValues[0], "")
                stripNetWeight(foundMilliliters.groupValues[0]) / 1000 // Found milliliters, convert to liters
            } else {
                0.0 // Nothing found
            }
        }

        val kilogramRegex = Regex("[0-9+],[0-9*]\\s*((кг)|(Кг))")
        val foundKilograms = kilogramRegex.find(text)
        if (foundKilograms != null) {
            text = text.replace(foundKilograms.groupValues[0], "")
            netWeight = stripNetWeight(foundKilograms.groupValues[0]) * 1000
        } else { // Not found kilograms, maybe we could find grams?
            val gramsRegex = Regex("[0-9+],[0-9*]\\s*[гГ]")
            val foundGrams = gramsRegex.find(text)
            netWeight = if (foundGrams != null) {
                text = text.replace(foundGrams.groupValues[0], "")
                stripNetWeight(foundGrams.groupValues[0])
            } else {
                0.0 // Nothing found
            }
        }

        val piecesRegex = Regex("[0-9+],*[0-9*]\\s*((шт)|(Шт))")
        val foundPieces = piecesRegex.find(text)
        if (foundPieces != null) {
            text = text.replace(foundPieces.groupValues[0], "")
            netWeight = stripNetWeight(foundPieces.groupValues[0])
        } else {
            netWeight = 0.0
        }

            name = text

        return AbstractProduct(0, "", name, netWeight, "", 0)
    }
}